<?php
// +---------------------------------------------+
// |     Copyright  2004  2006 mnProjects      |
// |     http://www.mnprojects.com               |
// |     DreamStats System by Miguel Nunes       |
// +---------------------------------------------+
//
//   D r e a m S t a t s
//
//   For Call of Duty 2 version 1.2

define('in_main', true);
define('in_dreamstats', true);

$offline = false;

################################# Include Core #################################

$file_coredotphp = "includes/core.php";

if (file_exists($file_coredotphp))
{
     include($file_coredotphp);
} else {
     echo '<b>' . $file_coredotphp . '</b> was not found! Please upload it again to your dreamstats folder.<br>';
     echo 'Without this file it\'s impossible to make dreamstats work.';
     exit();
}


################################### Counter ####################################

if ($enablecounter == 1)
{
    $dsc_query = "SELECT * FROM ds_conf";
    $dsc_result = mysql_query($dsc_query, $connection) or die(ErrorBox('DreamStats Error!', mysql_error()));
    $dsc_views = mysql_result($dsc_result, 0, "counter");

    $dsc_views++;

    $dsc_query = "UPDATE ds_conf SET counter = $dsc_views";
    mysql_query($dsc_query, $connection) or die(ErrorBox('DreamStats Error!', mysql_error()));
} else {
    echo '<!-- Counter Offline -->';
}



########################## Get Server IP -> Database ###########################

$server_ip = $row_svip['serverip'];
$server_port = $row_svip['serverport'];



############################# Connect to CoD Server ############################

$server_ip = "udp://" . $server_ip;
$connect = @fsockopen($server_ip, $server_port, $re, $errstr, 30); // TAKES LONGER TO LOAD

if( !$connect )
{
   $offline = true;
}

if ($connect) {
socket_set_timeout ($connect, 1, 000000);

@$send = "" . chr (0x02) . "getstatus";

if( !$send )
{
   $offline = true;
}

fputs($connect, $send);
fwrite ($connect, $send);

$output = fread ($connect, 1);

if (! empty ($output)) {
   do {
      $status_pre = socket_get_status ($connect);
      $output = $output . fread ($connect, 1);
      $status_post = socket_get_status ($connect);
   } while ($status_pre['unread_bytes'] != $status_post['unread_bytes']);
};

fclose($connect);

$output = explode("\\", $output);


################################ Get Server Info ###############################

$max_index = array_search ("gamename", $output);
$gamename = $output[$max_index+1];

$max_index = array_search ("mapname", $output);
$mapname = $output[$max_index+1];

$max_index = array_search ("sv_hostname", $output);
$hostname = $output[$max_index+1];

$max_index = array_search ("g_gametype", $output);
$gametype = $output[$max_index+1];

$max_index = array_search ("g_gametype", $output);
$gametypenofix = $output[$max_index+1];

$max_index = array_search ("sv_pure", $output);
$pure = $output[$max_index+1];

$max_index = array_search ("sv_pure", $output);
$pureun = $output[$max_index+1];

$max_index = array_search ("sv_minPing", $output);
$minping = $output[$max_index+1];

$max_index = array_search ("sv_maxPing", $output);
$maxping = $output[$max_index+1];

$max_index = array_search ("sv_maxRate", $output);
$maxrate = $output[$max_index+1];

$max_index = array_search ("sv_maxRate", $output);
$maxrateun = $output[$max_index+1];

$max_index = array_search ("pswrd", $output);
$password = $output[$max_index+1];

$max_index = array_search ("shortversion", $output);
$version = $output[$max_index+1];

$max_index = array_search ("scr_friendlyfire", $output);
$ff = $output[$max_index+1];

$max_index = array_search ("sv_maxclients", $output);
$slots = $output[$max_index+1];

$max_index = array_search ("sv_privateClients", $output);
$pvtcl = $output[$max_index+1];

$max_index = array_search ("protocol", $output);
$protocol = $output[$max_index+1];

$max_index = array_search ("sv_allowAnonymous", $output);
$alanyo = $output[$max_index+1];

$max_index = array_search ("sv_floodProtect", $output);
$floodp = $output[$max_index+1];

$max_index = array_search ("sv_privateClients", $output);
$pvtcl = $output[$max_index+1];

$max_index = array_search ("scr_killcam", $output);
$killcam = $output[$max_index+1];

$max_index = array_search ("g_antilag", $output);
$antilag = $output[$max_index+1];

$max_index = array_search ("g_antilag", $output);
$antilagnofix = $output[$max_index+1];

$max_index = array_search ("sv_voice", $output);
$voice = $output[$max_index+1];

$max_index = array_search ("sv_voice", $output);
$voicenofix = $output[$max_index+1];

$max_index = array_search ("sv_pure", $output);
$svpure = $output[$max_index+1];

$max_index = array_search ("sv_punkbuster", $output);
$punkbuster = $output[$max_index+1];


##################### Display slots without private slots ######################

$slots = $slots - $pvtcl;


############################# Recognize Gametypes ##############################

if ($gametype == "dm") {
$gametype = "Deathmatch";
}
if ($gametype == "sd") {
$gametype = "Search and Destroy";
}
if ($gametype == "tdm") {
$gametype = "Team Deathmatch";
}
if ($gametype == "hq") {
$gametype = "Headquarters";
}
if ($gametype == "ctf") {
$gametype = "Capture The Flag";
}


########################## Load Language Construction ##########################

include('includes/languagecreate.php');


############################### Find All Players ###############################

$last_value = count($output) - 1;
$players_string = $output[$last_value];
$players_string = explode("\n", $players_string);
$i = 1;
while ($i != count($players_string)) {
$split = explode(" ", $players_string[$i], 3);


$playerlist[$i-1]['score'] = $split[0];
@$playerlist[$i-1]['ping'] = $split[1];
@$playerlist[$i-1]['player'] = $split[2];


$i++;
}


############################## Create Nick Colors ##############################

function colored($color)
{
     global $row_frontpage;

         $color = str_replace('^1', "<font color=\"" . $row_frontpage['colorred']         .  "\">", $color);
         $color = str_replace("^2", "<font color=\"" . $row_frontpage['colorgreen']       .  "\">", $color);
         $color = str_replace("^3", "<font color=\"" . $row_frontpage['coloryellow']      .  "\">", $color);
         $color = str_replace("^4", "<font color=\"" . $row_frontpage['colorblue']        .  "\">", $color);
         $color = str_replace("^5", "<font color=\"" . $row_frontpage['colorlightblue']   .  "\">", $color);
         $color = str_replace("^6", "<font color=\"" . $row_frontpage['colorpink']        .  "\">", $color);
         $color = str_replace("^7", "<font color=\"" . $row_frontpage['colorwhite']       .  "\">", $color);
         $color = str_replace("^8", "<font color=\"" . $row_frontpage['colorlightgreen']  .  "\">", $color);
         $color = str_replace("^9", "<font color=\"" . $row_frontpage['colorgray']        .  "\">", $color);
         $color = str_replace("^0", "<font color=\"" . $row_frontpage['colorblack']       .  "\">", $color);

         return $color . "</font>";

}


############################## Create Player List ##############################

function cmp ($a, $b) {
if ($a["score"] > $b["score"]) {
return -1;
}


if ($a["score"] < $b["score"]) {
return 1;
}


if ($a["score"] == $b["score"]) {
return 0;
 }
}



@usort($playerlist, "cmp");
$players = count($playerlist) -1;


########################### Create Current Map Image ###########################

if (substr($mapname, 0, 3) == "dm/")
{
    $picture_src = str_replace("dm/", "", $mapname);

} else {

    $picture_src = str_replace("obj/", "", $mapname);
}

$picture_src = "images/mapimages/" . $picture_src . "." . $row_frontpage['mapimages'];

} //line 59

//Check if image exists, if not, display default.
if (!file_exists($picture_src))
{
    $picture_src = "images/unknowmap.jpg";
}


############################ Display SVOffline page ############################

if ($offline)
{
    include($rootpath . 'html/serveroffline.php');
    exit;
}



####################### This is for Call of Duty 2 only! #######################
## This needs to be below server offline page display code.

if ($gamename == "Call of Duty") {
           exit("Call of Duty (1) is not supported in this version of DreamStats. <a href='http://www.mnprojects.com/dreamstats/downloads_ds.php'>Click here to download CoD(1)/CoDUO 3.0 version...</a>");
}

if ($gamename == "CoD:United Offensive") {
           exit("Call of Duty United Offensive is not supported in this version of DreamStats. <a href='http://www.mnprojects.com/dreamstats/downloads_ds.php'>Click here to download CoD(1)/CoDUO 3.0 version...</a>");
}

if ($gamename == "etpro") {
           exit("Wolfenstein Enemy Territory is not supported in DreamStats ".$dsf->version."");
}

if ($gamename == "etmain") {
           exit("Wolfenstein Enemy Territory is not supported in DreamStats ".$dsf->version."");
}

if ($gamename == "tcetest") {
           exit("Wolfenstein Enemy Territory: True Combat Elite is not supported in DreamStats ".$dsf->version."");
}


##################### Red players text if players = slots ######################

$players_slash = "/";

if ($players >= $slots) //Counted already
{
        $players = '<font color="'.$row_frontpage['svfull'].'">' . $players . '</font>';
        $players_slash = '<font color="'.$row_frontpage['svfull'].'">/</font>';
        $slots = '<font color="'.$row_frontpage['svfull'].'">' . $slots . '</font>';
}


################################# Display Skin #################################

include('./skins/' . $row_lskin['skin'] . '/info.php');

if(!isset($_GET['smallone']))
{
    include('./html/design.php');
} else {
    include('./html/designsmall.php');
}

// DreamStats System by Miguel Nunes
// www.mnprojects.com
?>